<?php

/**
 * @version     1.0.0
 * @package     com_bibtexts
 * @copyright   Copyright (C) 2014. Todos los derechos reservados.
 * @license     Licencia Pública General GNU versión 2 o posterior. Consulte LICENSE.txt
 * @author      sergio carcel fernando <sergiocarfer@gmail.com> - http://
 */
// No direct access
defined('_JEXEC') or die;

jimport('joomla.application.component.controller');

class BibtextController extends JControllerLegacy {

    /**
     * Method to display a view.
     *
     * @param	boolean			$cachable	If true, the view output will be cached
     * @param	array			$urlparams	An array of safe url parameters and their variable types, for valid values see {@link JFilterInput::clean()}.
     *
     * @return	JController		This object to support chaining.
     * @since	1.5
     */
    public function display($cachable = false, $urlparams = false) {
        require_once JPATH_COMPONENT . '/helpers/bibtext.php';

        $view = JFactory::getApplication()->input->getCmd('view', 'bibtexts');
        JFactory::getApplication()->input->set('view', $view);

        parent::display($cachable, $urlparams);

        return $this;
    }
    
    function introduceOtraPublicacionManual(){
		$option = JFactory::getApplication()->input->get('option');
    	$modelo = $this->getModel('bibtexts');
    	$res = $modelo->introduceManual(JFactory::getApplication()->input->get,JFactory::getApplication()->input->get('entrytype'));
		if($res == 1){
    		$this->setMessage('Art&iacute;culo introducido!');
			$this->setRedirect('index.php?option=' . $option. '&view=bibtexts');
		}else if ($res == 2){
		    $this->setMessage('No se te olvide Completar el nombre de los nuevos autores!!!');
			$this->setRedirect('index.php?option=com_editarautores');
		}else if($res == 3){
		    $this->setMessage('El bibtexkey que est&aacute;s introduciendo ya existe, lo mismo est&aacute;s repitiendo un art&iacute;culo;');
		    $this->setRedirect('index.php?option=' . $option. '&view=bibtexts');
		}else{
    	 	$this->setMessage('Error al introducir!');
        	$this->setRedirect('index.php?option=' . $option. '&view=Error');
    	}
	}
    
    function introduceConferenceManual(){
		$option = JFactory::getApplication()->input->get('option');
    	$modelo = $this->getModel('bibtexts');
    	$res = $modelo->introduceManual(JFactory::getApplication()->input->get('post'),'CONFERENCE');
		if($res == 1){
    		$this->setMessage('Art&iacute;culo introducido!');
			$this->setRedirect('index.php?option=' . $option. '&view=bibtexts');
		}else if ($res == 2){
		    $this->setMessage('No se te olvide Completar el nombre de los nuevos autores!!!');
			$this->setRedirect('index.php?option=com_editarautores');
		}else if($res == 3){
		    $this->setMessage('El bibtexkey que est&aacute;s introduciendo ya existe, lo mismo est&aacute;s repitiendo un art&iacute;culo;');
		    $this->setRedirect('index.php?option=' . $option. '&view=bibtexts');
		}else{
    	 	$this->setMessage('Error al introducir!');
        	$this->setRedirect('index.php?option=' . $option. '&view=Error');
    	}
	}
	
	function introduceTesisManual(){
		$option = JFactory::getApplication()->input->get('option');
    	$modelo = $this->getModel('bibtexts');
    	$res = $modelo->introduceManual(JFactory::getApplication()->input->get('post'),'PHDTHESIS');
		if($res == 1){
    		$this->setMessage('Art&iacute;culo introducido!');
			$this->setRedirect('index.php?option=' . $option. '&view=bibtexts');
		}else if ($res == 2){
		    $this->setMessage('No se te olvide Completar el nombre de los nuevos autores!!!');
			$this->setRedirect('index.php?option=com_editarautores');
		}else if($res == 3){
		    $this->setMessage('El bibtexkey que est&aacute;s introduciendo ya existe, lo mismo est&aacute;s repitiendo un art&iacute;culo;');
		    $this->setRedirect('index.php?option=' . $option. '&view=bibtexts');
		}else{
    	 	$this->setMessage('Error al introducir!');
        	$this->setRedirect('index.php?option=' . $option. '&view=Error');
    	}
	}
	
	function introduceArticuloManual(){
		$option = JFactory::getApplication()->input->get('option');
    	$modelo = $this->getModel('bibtexts');
    	$res = $modelo->introduceManual(JFactory::getApplication()->input->get('post'),'ARTICLE');
		if($res == 1){
    		$this->setMessage('Art&iacute;culo introducido!');
			$this->setRedirect('index.php?option=' . $option. '&view=bibtexts');
		}else if ($res == 2){
		    $this->setMessage('No se te olvide Completar el nombre de los nuevos autores!!!');
			$this->setRedirect('index.php?option=com_editarautores');
		}else if($res == 3){
		    $this->setMessage('El bibtexkey que est&aacute;s introduciendo ya existe, lo mismo est&aacute;s repitiendo un art&iacute;culo;');
		    $this->setRedirect('index.php?option=' . $option. '&view=bibtexts');
		}else{
    	 	$this->setMessage('Error al introducir!');
        	$this->setRedirect('index.php?option=' . $option. '&view=Error');
    	}
	}
	
	function introduceEscrito(){
    	$option = JFactory::getApplication()->input->get('option');
    	$modelo = $this->getModel('bibtexts');
    	$res = $modelo->introduceEscrito(JFactory::getApplication()->input->get('post'));
    	if($res == 1){
    		$this->setMessage('Art&iacute;culo introducido!');
			$this->setRedirect('index.php?option=' . $option. '&view=bibtexts');
		}else if ($res == 2){
		    $this->setMessage('No se te olvide Completar el nombre de los nuevos autores!!!');
			$this->setRedirect('index.php?option=com_editarautores');
		}else if($res == 3){
		    $this->setMessage('El bibtexkey que est&aacute;s introduciendo ya existe, lo mismo est&aacute;s repitiendo un art&iacute;culo;');
		    $this->setRedirect('index.php?option=' . $option. '&view=bibtexts');
		}else{
    	 	$this->setMessage('Error al introducir!');
        	$this->setRedirect('index.php?option=' . $option. '&view=Error');
    	}
	}
	
	function introduceFichero(){
    	$option = JFactory::getApplication()->input->get('option');
    	$modelo = $this->getModel('bibtexts');
    	$res = $modelo->introduceFichero(JFactory::getApplication()->input->get('post'));
    	if($res == 1){
    		$this->setMessage('Fichero introducido!');
			$this->setRedirect('index.php?option=' . $option. '&view=bibtexts');
		}else if ($res == 2){
		    $this->setMessage('No se te olvide Completar el nombre de los nuevos autores!!!');
			$this->setRedirect('index.php?option=com_editarautores');
		}else if($res == 3){
		    $this->setMessage('ERROR: El bibtexkey que est&aacute;s introduciendo ya existe, lo mismo est&aacute;s repitiendo un art&iacute;culo;');
			$this->setRedirect('index.php?option=' . $option. '&view=bibtexts');
		}else if($res == 4){
		    $this->setMessage('ERROR: El bibtexkey que est&aacute;s introduciendo no tiene una extensi&oacute;n v&aacute;lida, esta debe ser .bib');
			$this->setRedirect('index.php?option=' . $option. '&view=bibtexts');
		}else{
    	 	$this->setMessage('ERROR: Error al introducir! ');
        	$this->setRedirect('index.php?option=' . $res. '&view=bibtexts');
    	}
	}
	
	function introduceDoi(){
		$option = JFactory::getApplication()->input->get('option');
    	$modelo = $this->getModel('bibtexts');
    	$res = $modelo->introduceDoi(JFactory::getApplication()->input->get('post'));

    	if($res == 1){
    		$this->setMessage('DOI introducido!');
			$this->setRedirect('index.php?option=' . $option. '&view=bibtexts');
		}
	}
	
	
	
	

}
