<?php

/**
 * @version     1.0.0
 * @package     com_verarticulos
 * @copyright   Copyright (C) 2014. Todos los derechos reservados.
 * @license     Licencia Pblica General GNU versin 2 o posterior. Consulte LICENSE.txt
 * @author      sergio carcel fernando <sergiocarfer@gmail.com> - http://
 */
defined('_JEXEC') or die;

jimport('joomla.application.component.modellist');

/**
 * Methods supporting a list of Verarticulos records.
 */
class VerarticulosModelVertexto extends JModelList {
    
    //declaracion de variables	
	var $datos;
	var $tesis;
	var $congresos;
	var $otrasPub;
	var $autores;
	var $articulosdeunapersona;
	var $articulosdeunapersonaPrimero;
	var $tesisdeunapersona;
	var $tesisdeunapersonaPrimero;
	var $congresosdeunaapersona;
	var $congresosdeunaapersonaPrimero;
	var $otrasdeunapersona;
	var $otrasdeunapersonaPrimero;
	
      /**
     * Constructor.
     *
     * @param    array    An optional associative array of configuration settings.
     * @see        JController
     * @since    1.6
     */
     
     //NUEVO
	function getArticulos(){
		$anio = JFactory::getApplication()->input->get('year');
		if ($anio == "" or $anio == "ninguno"){
			$anio = -1;
		}
        if (empty( $this->datos )){
			if ($anio == -1){
				$query = "SELECT * FROM #__publicaciones_escritos e WHERE (tipo = \"ARTICLE\" ) order by `year` desc, title;";
			}else{
				$query = "SELECT * FROM #__publicaciones_escritos e WHERE (tipo = \"ARTICLE\" and year = ".$anio." ) order by `year` desc, title;";
			}
            $this->datos = $this->_getList( $query );
        }
 
        return $this->datos;
    }
	
	function getTesis(){
		$anio = JFactory::getApplication()->input->get('year');
		if ($anio == "" or $anio == "ninguno"){
			$anio = -1;
		}
        if (empty( $this->tesis )){
			if ($anio == -1){
				$query = "SELECT * FROM #__publicaciones_escritos e WHERE (tipo = \"PHDTHESIS\" ) order by `year` desc, title;";
			}else{
				$query = "SELECT * FROM #__publicaciones_escritos e WHERE (tipo = \"PHDTHESIS\" and year = ".$anio." ) order by `year` desc, title;";
			}
            $this->tesis = $this->_getList( $query );
        }
 
        return $this->tesis;
    }
    
    function getCongresos(){
		$anio = JFactory::getApplication()->input->get('year');
		if ($anio == "" or $anio == "ninguno"){
			$anio = -1;
		}
        if (empty( $this->congresos )){
			if ($anio == -1){
				$query = "SELECT * FROM #__publicaciones_escritos e WHERE ((tipo = \"CONFERENCE\" OR tipo = \"INPROCEEDINGS\") ) order by `anio` desc, `year` desc, title;";
			}else{
				$query = "SELECT * FROM #__publicaciones_escritos e WHERE ((tipo = \"CONFERENCE\" OR tipo = \"INPROCEEDINGS\") and anio = ".$anio." ) order by `anio` desc, `year` desc, title;";
			}
            $this->congresos = $this->_getList( $query );
        }
 
        return $this->congresos;
    }
    
    function getOtrasPublicaciones(){
		$anio = JFactory::getApplication()->input->get('year');
		if ($anio == "" or $anio == "ninguno"){
			$anio = -1;
		}
        if (empty( $this->otrasPub)){
			if($anio == -1){
				$query = "SELECT * FROM #__publicaciones_escritos e WHERE (tipo <> \"ARTICLE\" AND tipo <> \"PHDTHESIS\" AND tipo <> \"CONFERENCE\" AND tipo <> \"INPROCEEDINGS\" ) order by `year` desc, title;";
			}else{
				$query = "SELECT * FROM #__publicaciones_escritos e WHERE (tipo <> \"ARTICLE\" AND tipo <> \"PHDTHESIS\" AND tipo <> \"CONFERENCE\" AND tipo <> \"INPROCEEDINGS\" AND year = ".$anio." ) order by `year` desc, title;";
			}
            $this->otrasPub = $this->_getList( $query );
        }
 
        return $this->otrasPub;
    }
	
	function getArticulosDeUnaPersona(){
		$persona = JFactory::getApplication()->input->getString('persona');
		$primerAut = JFactory::getApplication()->input->get('primero');
		$anio = JFactory::getApplication()->input->get('year');
		if ($anio == "" or $anio == "ninguno"){
			$anio = -1;
		}
		if ($persona == ""){
			$persona = -1;
		}
		if ($persona == "ninguno"){
			$persona = -1;
		}
		
		if (empty( $this->articulosdeunapersona )){		
			if ($anio == -1){
				if ( $primerAut == "on" ){
					$query = "SELECT e.author,e.title,e.id,e.journal, e.volume, e.pages, e.month, e.year, e.url, e.visible FROM #__publicaciones_escritos "
					."e,#__publicaciones_pertenece p, #__publicaciones_autor a where (e.tipo = \"ARTICLE\"  and e.id = p.escrito "
					."and p.autor = a.id and a.id in(SELECT id FROM  #__publicaciones_autor WHERE nombre = '".$persona."') "
					."and e.primerAutor in (SELECT abreviado FROM  jos_publicaciones_autor WHERE nombre = '".$persona."')) "
					."order by `year` desc, title;";
				}else{
					$query = "SELECT e.author,e.title,e.id,e.journal, e.volume, e.pages, e.month, e.year, e.url, e.visible FROM #__publicaciones_escritos "
					."e,#__publicaciones_pertenece p, #__publicaciones_autor a where (e.tipo = \"ARTICLE\"  and e.id = p.escrito "
					."and p.autor = a.id and a.id in(SELECT id FROM  #__publicaciones_autor WHERE nombre = '".$persona."')) "
					."order by `year` desc, title;";
				}
			}else{
								if ( $primerAut == "on" ){
					$query = "SELECT e.author,e.title,e.id,e.journal, e.volume, e.pages, e.month, e.year, e.url, e.visible FROM #__publicaciones_escritos "
					."e,#__publicaciones_pertenece p, #__publicaciones_autor a where (e.year = ".$anio." AND e.tipo = \"ARTICLE\"  and e.id = p.escrito "
					."and p.autor = a.id and a.id in(SELECT id FROM  #__publicaciones_autor WHERE nombre = '".$persona."') "
					."and e.primerAutor in (SELECT abreviado FROM  jos_publicaciones_autor WHERE nombre = '".$persona."')) "
					."order by `year` desc, title;";
				}else{
					$query = "SELECT e.author,e.title,e.id,e.journal, e.volume, e.pages, e.month, e.year, e.url, e.visible FROM #__publicaciones_escritos "
					."e,#__publicaciones_pertenece p, #__publicaciones_autor a where (e.year = ".$anio." AND e.tipo = \"ARTICLE\"  and e.id = p.escrito "
					."and p.autor = a.id and a.id in(SELECT id FROM  #__publicaciones_autor WHERE nombre = '".$persona."')) "
					."order by `year` desc, title;";
				}

			}
            $this->articulosdeunapersona = $this->_getList( $query );
        }
 
        return $this->articulosdeunapersona;
	}
	
	function getTesisDeUnaPersona(){
		$persona = JFactory::getApplication()->input->getString('persona');
		$primerAut = JFactory::getApplication()->input->get('primero');
		$anio = JFactory::getApplication()->input->get('year');
		if ($anio == "" or $anio == "ninguno"){
			$anio = -1;
		}
		if ($persona == ""){
			$persona = -1;
		}
		if ($persona == "ninguno"){
			$persona = -1;
		}
		
		if (empty( $this->tesisdeunapersona )){	
			if ($anio == -1){
				if ( $primerAut == "on" ){
					$query = "SELECT e.author,e.title, e.id, e.journal, e.tipo, e.volume, e.pages, e.year, e.month, e.author, e.school, e.url, e.booktitle, e.note, e.visible FROM ".
					"#__publicaciones_escritos e,#__publicaciones_pertenece p, #__publicaciones_autor a where ( e.tipo = \"PHDTHESIS\"  and ".
					"e.id = p.escrito and p.autor = a.id and a.id in (SELECT id FROM #__publicaciones_autor WHERE nombre = '".$persona."') ".
					"and e.primerAutor in (SELECT abreviado FROM  jos_publicaciones_autor WHERE nombre = '".$persona."')) order by `year` desc, title;";
				}else{
					$query = "SELECT e.author,e.title, e.id, e.journal, e.tipo, e.volume, e.pages, e.year, e.month, e.author, e.school, e.url, e.booktitle, e.note, e.visible FROM ".
					"#__publicaciones_escritos e,#__publicaciones_pertenece p, #__publicaciones_autor a where ( e.tipo = \"PHDTHESIS\"  and ".
					"e.id = p.escrito and p.autor = a.id and a.id in (SELECT id FROM #__publicaciones_autor WHERE nombre = '".$persona."'))".
					"order by `year` desc, title;";
				} 
			}else{
				if ( $primerAut == "on" ){
					$query = "SELECT e.author,e.title, e.id, e.journal, e.tipo, e.volume, e.pages, e.year, e.month, e.author, e.school, e.url, e.booktitle, e.note, e.visible FROM ".
					"#__publicaciones_escritos e,#__publicaciones_pertenece p, #__publicaciones_autor a where (e.year = ".$anio." AND e.tipo = \"PHDTHESIS\"  and ".
					"e.id = p.escrito and p.autor = a.id and a.id in (SELECT id FROM #__publicaciones_autor WHERE nombre = '".$persona."') ".
					"and e.primerAutor in (SELECT abreviado FROM  jos_publicaciones_autor WHERE nombre = '".$persona."')) order by `year` desc, title;";
				}else{
					$query = "SELECT e.author,e.title, e.id, e.journal, e.tipo, e.volume, e.pages, e.year, e.month, e.author, e.school, e.url, e.booktitle, e.note, e.visible FROM ".
					"#__publicaciones_escritos e,#__publicaciones_pertenece p, #__publicaciones_autor a where (e.year = ".$anio." AND e.tipo = \"PHDTHESIS\"  and ".
					"e.id = p.escrito and p.autor = a.id and a.id in (SELECT id FROM #__publicaciones_autor WHERE nombre = '".$persona."'))".
					"order by `year` desc, title;";
				} 

			}
            $this->tesisdeunapersona = $this->_getList( $query );
        }
 
        return $this->tesisdeunapersona;
	}
	
	function getCongresosDeUnaPersona(){
		$persona = JFactory::getApplication()->input->getString('persona');
		$primerAut = JFactory::getApplication()->input->get('primero');
		$anio = JFactory::getApplication()->input->get('year');
		if ($anio == "" or $anio == "ninguno"){
			$anio = -1;
		}
		if ($persona == ""){
			$persona = -1;
		}
		if ($persona == "ninguno"){
			$persona = -1;
		}
		
		if (empty( $this->congresosdeunapersona )){
			if ($anio == -1){
				if( $primerAut == "on" ){
					$query = "SELECT e.author,e.title, e.id, e.journal, e.tipo, e.volume, e.pages, e.year, e.month, e.author, e.school, e.url, e.booktitle, e.note, e.visible FROM ".
					"#__publicaciones_escritos e,#__publicaciones_pertenece p, #__publicaciones_autor a where ( (e.tipo = \"CONFERENCE\" OR e.tipo = \"INPROCEEDINGS\")  and ".
					"e.id = p.escrito and p.autor = a.id and a.id in (SELECT id FROM #__publicaciones_autor WHERE nombre = '".$persona."')".
					"and e.primerAutor in (SELECT abreviado FROM  jos_publicaciones_autor WHERE nombre = '".$persona."')) order by `anio` desc, `year` desc, title;";
				}else{
					$query = "SELECT e.author,e.title, e.id, e.journal, e.tipo, e.volume, e.pages, e.year, e.month, e.author, e.school, e.url, e.booktitle, e.note, e.visible FROM ".
					"#__publicaciones_escritos e,#__publicaciones_pertenece p, #__publicaciones_autor a where ( (e.tipo = \"CONFERENCE\" OR e.tipo = \"INPROCEEDINGS\")  and ".
					"e.id = p.escrito and p.autor = a.id and a.id in (SELECT id FROM #__publicaciones_autor WHERE nombre = '".$persona."'))".
					"order by `anio` desc, `year` desc, title;";
				}
			}else{
				if( $primerAut == "on" ){
					$query = "SELECT e.author,e.title, e.id, e.journal, e.tipo, e.volume, e.pages, e.year, e.month, e.author, e.school, e.url, e.booktitle, e.note, e.visible FROM ".
					"#__publicaciones_escritos e,#__publicaciones_pertenece p, #__publicaciones_autor a where (e.anio=".$anio." AND (e.tipo = \"CONFERENCE\" OR e.tipo = \"INPROCEEDINGS\")  and ".
					"e.id = p.escrito and p.autor = a.id and a.id in (SELECT id FROM #__publicaciones_autor WHERE nombre = '".$persona."')".
					"and e.primerAutor in (SELECT abreviado FROM  jos_publicaciones_autor WHERE nombre = '".$persona."')) order by `anio` desc, `year` desc, title;";
				}else{
					$query = "SELECT e.author,e.title, e.id, e.journal, e.tipo, e.volume, e.pages, e.year, e.month, e.author, e.school, e.url, e.booktitle, e.note, e.visible FROM ".
					"#__publicaciones_escritos e,#__publicaciones_pertenece p, #__publicaciones_autor a where (e.anio=".$anio." AND (e.tipo = \"CONFERENCE\" OR e.tipo = \"INPROCEEDINGS\")  and ".
					"e.id = p.escrito and p.autor = a.id and a.id in (SELECT id FROM #__publicaciones_autor WHERE nombre = '".$persona."'))".
					"order by `anio` desc, `year` desc, title;";
				}
			
			}
            $this->congresosdeunapersona = $this->_getList( $query );
        }
 
        return $this->congresosdeunapersona;
	}
	
	function getOtrasPubDeUnaPersona(){
		$persona = JFactory::getApplication()->input->getString('persona');
		$primerAut = JFactory::getApplication()->input->get('primero');
		$anio = JFactory::getApplication()->input->get('year');
		if ($anio == "" or $anio == "ninguno"){
			$anio = -1;
		}
		if ($persona == ""){
			$persona = -1;
		}
		if ($persona == "ninguno"){
			$persona = -1;
		}
		
		if (empty( $this->otrasdeunapersona )){
			if ($anio == -1){
				if ( $primerAut == "on" ){
					$query = "SELECT e.author,e.title, e.id, e.journal, e.tipo, e.volume, e.pages, e.year, e.month, e.author, e.school, e.url, e.visible FROM ".
					"#__publicaciones_escritos e,#__publicaciones_pertenece p, #__publicaciones_autor a where ( e.tipo <> \"PHDTHESIS\" and ".
					"e.tipo <> \"ARTICLE\" and e.tipo <> \"CONFERENCE\" AND e.tipo <> \"INPROCEEDINGS\"  and e.id = p.escrito and p.autor = a.id and a.id in (SELECT id FROM ".
					"#__publicaciones_autor WHERE nombre = '".$persona."') and e.primerAutor in (SELECT abreviado FROM  jos_publicaciones_autor WHERE nombre = '".$persona."')) ".
					"order by `year` desc, title;";
				}else{
					$query = "SELECT e.author,e.title, e.id, e.journal, e.tipo, e.volume, e.pages, e.year, e.month, e.author, e.school, e.url , e.visible FROM ".
					"#__publicaciones_escritos e,#__publicaciones_pertenece p, #__publicaciones_autor a where ( e.tipo <> \"PHDTHESIS\" and ".
					"e.tipo <> \"ARTICLE\" and e.tipo <> \"CONFERENCE\" AND e.tipo <> \"INPROCEEDINGS\"  and e.id = p.escrito and p.autor = a.id and a.id in (SELECT id FROM ".
					"#__publicaciones_autor WHERE nombre = '".$persona."')) order by `year` desc, title;";
				}
			}else{
				if ( $primerAut == "on" ){
					$query = "SELECT e.author,e.title, e.id, e.journal, e.tipo, e.volume, e.pages, e.year, e.month, e.author, e.school, e.url, e.visible FROM ".
					"#__publicaciones_escritos e,#__publicaciones_pertenece p, #__publicaciones_autor a where (e.year=".$anio." AND e.tipo <> \"PHDTHESIS\" and ".
					"e.tipo <> \"ARTICLE\" and e.tipo <> \"CONFERENCE\" AND e.tipo <> \"INPROCEEDINGS\"  and e.id = p.escrito and p.autor = a.id and a.id in (SELECT id FROM ".
					"#__publicaciones_autor WHERE nombre = '".$persona."') and e.primerAutor in (SELECT abreviado FROM  jos_publicaciones_autor WHERE nombre = '".$persona."')) ".
					"order by `year` desc, title;";
				}else{
					$query = "SELECT e.author,e.title, e.id, e.journal, e.tipo, e.volume, e.pages, e.year, e.month, e.author, e.school, e.url, e.visible FROM ".
					"#__publicaciones_escritos e,#__publicaciones_pertenece p, #__publicaciones_autor a where (e.year=".$anio." AND e.tipo <> \"PHDTHESIS\" and ".
					"e.tipo <> \"ARTICLE\" and e.tipo <> \"CONFERENCE\" AND e.tipo <> \"INPROCEEDINGS\"  and e.id = p.escrito and p.autor = a.id and a.id in (SELECT id FROM ".
					"#__publicaciones_autor WHERE nombre = '".$persona."')) order by `year` desc, title;";
				}

			}
            $this->otrasdeunapersona = $this->_getList( $query );
        }
 
        return $this->otrasdeunapersona;
	}
	
	function view_pathway(){
		global $mainframe;
	
		$autor = JFactory::getApplication()->input->getString('persona');
		$primerAut = JFactory::getApplication()->input->get('primero');
		$anio = JFactory::getApplication()->input->get('year');
		$mostrarInvisibles = JFactory::getApplication()->input->get('mostrarInvisibles');
		if ($anio == "" or $anio == "ninguno"){
			$anio = -1;
		}
		if ($anio == -1){
			if($autor == "ninguno" || $autor == ""){
				$breadcrumbs = & $mainframe->getPathWay();
				$breadcrumbs->addItem( JText::_('PRESENTACIONES'),sefRelToAbs( 'index.php?option=com_verarticulos' ) );
				$breadcrumbs->addItem( "Texto Plano", '' );
			}else{
				$breadcrumbs = & $mainframe->getPathWay();
				$breadcrumbs->addItem( JText::_('PRESENTACIONES'), sefRelToAbs( 'index.php?option=com_verarticulos' ) );
				$breadcrumbs->addItem( $autor, sefRelToAbs( "index.php?option=com_verarticulos&autor=".$autor."&mostrarInvisibles=".$mostrarInvisibles."&primerAutor=".$primerAut."&consultar=on" ) );
				$breadcrumbs->addItem( "Texto Plano", '' );
			}
		}else{
			if($autor == "ninguno" || $autor == ""){
				$breadcrumbs = & $mainframe->getPathWay();
				$breadcrumbs->addItem( JText::_('PRESENTACIONES'),sefRelToAbs( 'index.php?option=com_verarticulos' ) );
				$breadcrumbs->addItem( $anio, sefRelToAbs( "index.php?option=com_verarticulos&autor=ninguno&mostrarInvisibles=".$mostrarInvisibles."&primerAutor=".$primerAut."&year=".$anio."&consultar=on" ) );
				$breadcrumbs->addItem( "Texto Plano", '' );
			}else{
				$breadcrumbs = & $mainframe->getPathWay();
				$breadcrumbs->addItem( JText::_('PRESENTACIONES'), sefRelToAbs( 'index.php?option=com_verarticulos' ) );
				$breadcrumbs->addItem( $autor, sefRelToAbs( "index.php?option=com_verarticulos&autor=".$autor."&mostrarInvisibles=".$mostrarInvisibles."&primerAutor=".$primerAut."&consultar=on" ) );
				$breadcrumbs->addItem( $anio, sefRelToAbs( "index.php?option=com_verarticulos&autor=".$autor."&mostrarInvisibles=".$mostrarInvisibles."&primerAutor=".$primerAut."&year=".$anio."&consultar=on" ) );
				$breadcrumbs->addItem("Texto Plano", '' );
			}
		}
	}	
	//FIN NUEVO
    
    public function __construct($config = array()) {
        parent::__construct($config);
    }

    /**
     * Method to auto-populate the model state.
     *
     * Note. Calling getState in this method will result in recursion.
     *
     * @since	1.6
     */
    protected function populateState($ordering = null, $direction = null) {

        // Initialise variables.
        $app = JFactory::getApplication();

        // List state information
        $limit = $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'));
        $this->setState('list.limit', $limit);

        $limitstart = JFactory::getApplication()->input->getInt('limitstart', 0);
        $this->setState('list.start', $limitstart);

        

        // List state information.
        parent::populateState($ordering, $direction);
    }

    /**
     * Build an SQL query to load the list data.
     *
     * @return	JDatabaseQuery
     * @since	1.6
     */
    protected function getListQuery() {
		$db		= $this->getDbo();
		$query	= $db->getQuery(true);
		return $query;
	}


	public function getItems() {
        return parent::getItems();
    }
    
}