<?php

/**
 * @version     1.5.0
 * @package     com_bibtexts
 * @copyright   Copyright (C) 2014. Todos los derechos reservados.
 * @license     Licencia Pública General GNU versión 2 o posterior. Consulte LICENSE.txt
 * @author      sergio carcel fernando <sergiocarfer@gmail.com> - http://
 */
// No direct access
defined('_JEXEC') or die;

jimport('joomla.application.component.controller');

class BibtextController extends JControllerLegacy {

    /**
     * Metodo para mostrar la vista.
     *
     * @param	boolean			$cachable	Si es true, la salida de la vista se almacena en caché
     * @param	array			$urlparams	An array of safe url parameters and their variable types, for valid values see {@link JFilterInput::clean()}.
     *
     * @return	JController		This object to support chaining.
     * @since	1.5
     */
     //Metodo para mostrar la vista
    public function display($cachable = false, $urlparams = false) {
        require_once JPATH_COMPONENT . '/helpers/bibtext.php';

        $view = JFactory::getApplication()->input->getCmd('view', 'bibtexts');
        JFactory::getApplication()->input->set('view', $view);

        parent::display($cachable, $urlparams);

        return $this;
    }
    //metodo que llama a la funcion introduceManual del modelo Bibtexts para almacenar en la base de datos un articulo de tipo otra publicación
    function introduceOtraPublicacionManual(){
		$option = JFactory::getApplication()->input->get('option');
    	$modelo = $this->getModel('bibtexts');
    	$res = $modelo->introduceManual(JFactory::getApplication()->input->get,JFactory::getApplication()->input->get('entrytype'));
		//mensaje que muestra dependiendo de lo que devuelva la función
        if($res == 1){
    		$this->setMessage('Art&iacute;culo introducido!');
			$this->setRedirect('index.php?option=' . $option. '&view=bibtexts');
		}else if ($res == 2){
		    $this->setMessage('No se te olvide Completar el nombre de los nuevos autores!!!');
			$this->setRedirect('index.php?option=com_editarautores');
		}else if($res == 3){
		    $this->setMessage('El bibtexkey que est&aacute;s introduciendo ya existe, lo mismo est&aacute;s repitiendo un art&iacute;culo;');
		    $this->setRedirect('index.php?option=' . $option. '&view=bibtexts');
		}else{
    	 	$this->setMessage('Error al introducir!');
        	$this->setRedirect('index.php?option=' . $option. '&view=Error');
    	}
	}
      //metodo que llama a la funcion introduceManual del modelo Bibtexts para almacenar en la base de datos un articulo de tipo conferencia
    function introduceConferenceManual(){
		$option = JFactory::getApplication()->input->get('option');
    	$modelo = $this->getModel('bibtexts');
    	$res = $modelo->introduceManual(JFactory::getApplication()->input->get('post'),'CONFERENCE');
		//mensaje que muestra dependiendo de lo que devuelva la función
        if($res == 1){
    		$this->setMessage('Art&iacute;culo introducido!');
			$this->setRedirect('index.php?option=' . $option. '&view=bibtexts');
		}else if ($res == 2){
		    $this->setMessage('No se te olvide Completar el nombre de los nuevos autores!!!');
			$this->setRedirect('index.php?option=com_editarautores');
		}else if($res == 3){
		    $this->setMessage('El bibtexkey que est&aacute;s introduciendo ya existe, lo mismo est&aacute;s repitiendo un art&iacute;culo;');
		    $this->setRedirect('index.php?option=' . $option. '&view=bibtexts');
		}else{
    	 	$this->setMessage('Error al introducir!');
        	$this->setRedirect('index.php?option=' . $option. '&view=Error');
    	}
	}
	  //metodo que llama a la funcion introduceManual del modelo Bibtexts para almacenar en la base de datos un articulo de tipo Tesis
	function introduceTesisManual(){
		$option = JFactory::getApplication()->input->get('option');
    	$modelo = $this->getModel('bibtexts');
    	$res = $modelo->introduceManual(JFactory::getApplication()->input->get('post'),'PHDTHESIS');
		//mensaje que muestra dependiendo de lo que devuelva la función
        if($res == 1){
    		$this->setMessage('Art&iacute;culo introducido!');
			$this->setRedirect('index.php?option=' . $option. '&view=bibtexts');
		}else if ($res == 2){
		    $this->setMessage('No se te olvide Completar el nombre de los nuevos autores!!!');
			$this->setRedirect('index.php?option=com_editarautores');
		}else if($res == 3){
		    $this->setMessage('El bibtexkey que est&aacute;s introduciendo ya existe, lo mismo est&aacute;s repitiendo un art&iacute;culo;');
		    $this->setRedirect('index.php?option=' . $option. '&view=bibtexts');
		}else{
    	 	$this->setMessage('Error al introducir!');
        	$this->setRedirect('index.php?option=' . $option. '&view=Error');
    	}
	}
	  //metodo que llama a la funcion introduceManual del modelo Bibtexts para almacenar en la base de datos un articulo de tipo articulo.
	function introduceArticuloManual(){
		$option = JFactory::getApplication()->input->get('option');
    	$modelo = $this->getModel('bibtexts');
    	$res = $modelo->introduceManual(JFactory::getApplication()->input->get('post'),'ARTICLE');
		//mensaje que muestra dependiendo de lo que devuelva la función
        if($res == 1){
    		$this->setMessage('Art&iacute;culo introducido!');
			$this->setRedirect('index.php?option=' . $option. '&view=bibtexts');
		}else if ($res == 2){
		    $this->setMessage('No se te olvide Completar el nombre de los nuevos autores!!!');
			$this->setRedirect('index.php?option=com_editarautores');
		}else if($res == 3){
		    $this->setMessage('El bibtexkey que est&aacute;s introduciendo ya existe, lo mismo est&aacute;s repitiendo un art&iacute;culo;');
		    $this->setRedirect('index.php?option=' . $option. '&view=bibtexts');
		}else{
    	 	$this->setMessage('Error al introducir!');
        	$this->setRedirect('index.php?option=' . $option. '&view=Error');
    	}
	}
	  //metodo que llama a la funcion introduceEscrito del modelo Bibtexts para almacenar en la base de datos un articulo en formato bibtex
	function introduceEscrito(){
    	$option = JFactory::getApplication()->input->get('option');
    	$modelo = $this->getModel('bibtexts');
    	$res = $modelo->introduceEscrito(JFactory::getApplication()->input->get('post'));
    	//mensaje que muestra dependiendo de lo que devuelva la función
        if($res == 1){
    		$this->setMessage('Art&iacute;culo introducido!');
			$this->setRedirect('index.php?option=' . $option. '&view=bibtexts');
		}else if ($res == 2){
		    $this->setMessage('No se te olvide Completar el nombre de los nuevos autores!!!');
			$this->setRedirect('index.php?option=com_editarautores');
		}else if($res == 3){
		    $this->setMessage('El bibtexkey que est&aacute;s introduciendo ya existe, lo mismo est&aacute;s repitiendo un art&iacute;culo;');
		    $this->setRedirect('index.php?option=' . $option. '&view=bibtexts');
		}else{
    	 	$this->setMessage('Error al introducir!');
        	$this->setRedirect('index.php?option=' . $option. '&view=Error');
    	}
	}
	  //metodo que llama a la funcion introduceFichero del modelo Bibtexts para almacenar en la base de datos articulos leyendolos de un archivo .bib
	function introduceFichero(){
    	$option = JFactory::getApplication()->input->get('option');
    	$modelo = $this->getModel('bibtexts');
    	$res = $modelo->introduceFichero(JFactory::getApplication()->input->get('post'));
    	//mensaje que muestra dependiendo de lo que devuelva la función
        if($res == 1){
    		$this->setMessage('Fichero introducido!');
			$this->setRedirect('index.php?option=' . $option. '&view=bibtexts');
		}else if ($res == 2){
		    $this->setMessage('No se te olvide Completar el nombre de los nuevos autores!!!');
			$this->setRedirect('index.php?option=com_editarautores');
		}else if($res == 3){
		    $this->setMessage('ERROR: El bibtexkey que est&aacute;s introduciendo ya existe, lo mismo est&aacute;s repitiendo un art&iacute;culo;');
			$this->setRedirect('index.php?option=' . $option. '&view=bibtexts');
		}else if($res == 4){
		    $this->setMessage('ERROR: El bibtexkey que est&aacute;s introduciendo no tiene una extensi&oacute;n v&aacute;lida, esta debe ser .bib');
			$this->setRedirect('index.php?option=' . $option. '&view=bibtexts');
		}else{
    	 	$this->setMessage('ERROR: No ha seleccionado ningun fichero! ');
     		$this->setRedirect('index.php?option=' . $option. '&view=bibtexts');
    	}
	}
	  //metodo que llama a la funcion introduceDoi del modelo Bibtexts para almacenar en la base de datos un articulo introduciendo su doi y buscando el artículo mediante una API
	function introduceDoi(){
		$option = JFactory::getApplication()->input->get('option');
    	$modelo = $this->getModel('bibtexts');
    	$res = $modelo->introduceDoi(JFactory::getApplication()->input->get('post'));
        //mensaje que muestra dependiendo de lo que devuelva la función
    	if($res == 1){
    		$this->setMessage('DOI introducido!');
			$this->setRedirect('index.php?option=' . $option. '&view=bibtexts');
		}
	}
	
	
	
	

}
