<?php

/**
 * @version     1.3.0
 * @package     com_verarticulos
 * @copyright   Copyright (C) 2014. Todos los derechos reservados.
 * @license     Licencia Pública General GNU versión 2 o posterior. Consulte LICENSE.txt
 * @author      sergio carcel fernando <sergiocarfer@gmail.com> - http://
 */
// No direct access
defined('_JEXEC') or die;

jimport('joomla.application.component.controller');
//clase del controlador de verarticulos
class VerarticulosController extends JControllerLegacy {

    /**
     * Metodo que muestra la vista
     *
     * @param	boolean			$cachable	Si es true, la salida de la vista se almacena en caché
     * @param	array			$urlparams	An array of safe url parameters and their variable types, for valid values see {@link JFilterInput::clean()}.
     *
     * @return	JController		This object to support chaining.
     * @since	1.5
     */
     
     //funcion para mostrar la vista por defecto
    public function display($cachable = false, $urlparams = false) {
        require_once JPATH_COMPONENT . '/helpers/verarticulos.php';

        $view = JFactory::getApplication()->input->getCmd('view', 'verarticulos');
        JFactory::getApplication()->input->set('view', $view);

        parent::display($cachable, $urlparams);

        return $this;
    }
    
    //funcion que conecta la vista editarbibtex con el modelo verarticulos y la funcion borrarpublicacion del mismo	
	function borrarPublicacion(){
		$option = JFactory::getApplication()->input->get('option');
		$modelo = $this->getModel('verarticulos');
		$res = $modelo->borrarPublication(JFactory::getApplication()->input->get('id'));
		if($res == 1){
    		$this->setMessage('Art&iacute;culo borrado!');
			$this->setRedirect('index.php?option=' . $option. '&view=verarticulos');
		}
	}	
	   //funcion que conecta la vista editarbibtex con el modelo verarticulos y la funcion ocultarpublicacion del mismo	
	function ocultarPublicacion(){
		$option = JFactory::getApplication()->input->get('option');
		$modelo = $this->getModel('verarticulos');
		$res = $modelo->ocultarPublication(JFactory::getApplication()->input->get('id'));
		if($res == 1){
    		$this->setMessage('Publicaci&oacute;n invisible!');
			$this->setRedirect('index.php?option=' . $option. '&view=verarticulos');
		}
	}
	//funcion que conecta la vista editarbibtex con el modelo verarticulos y la funcion desocultarpublicacion del mismo	
	function desocultarPublicacion(){
		$option = JFactory::getApplication()->input->get('option');
		$modelo = $this->getModel('verarticulos');
		$res = $modelo->desocultarPublication(JFactory::getApplication()->input->get('id'));
		if($res == 1){
    		$this->setMessage('Publicaci&oacute;n visible de nuevo!');
			$this->setRedirect('index.php?option=' . $option. '&view=verarticulos');
		}
	}
 
}
