<?php

/**
 * @version     1.5.0
 * @package     com_bibtext
 * @copyright   Copyright (C) 2014. Todos los derechos reservados.
 * @license     Licencia PÃºblica General GNU versiÃ³n 2 o posterior. Consulte LICENSE.txt
 * @author      sergio carcel fernando <sergiocarfer@gmail.com> - http://
 */
defined('_JEXEC') or die;

jimport('joomla.application.component.modellist');

/**
 * Methods supporting a list of Bibtext records.
 */
class BibtextModelBibtexts extends JModelList {

    /**
     * Constructor.
     *
     * @param    array    An optional associative array of configuration settings.
     * @see        JController
     * @since    1.6
     */
     
     
     
     //funcion que introduce en la base de datos un artículo,congreso,tesis u otra publicación que se ha introudcido rellenando el formulario
     function introduceManual($post, $entrytype){
		$res = 0;
		$bibtexkey = addslashes(JFactory::getApplication()->input->getString('bibtexkey'));
		$author = addslashes(JFactory::getApplication()->input->getString('author'));
		$title = addslashes(JFactory::getApplication()->input->getString('title'));
		$journal = addslashes(JFactory::getApplication()->input->getString('journal'));
		$year = addslashes(JFactory::getApplication()->input->getString('year'));
		$volume = addslashes(JFactory::getApplication()->input->getString('volume'));
		$pages = addslashes(JFactory::getApplication()->input->getString('pages'));
		$number = addslashes(JFactory::getApplication()->input->getString('number'));
		$month = addslashes(JFactory::getApplication()->input->getString('month'));
		$eid = addslashes(JFactory::getApplication()->input->getString('eid'));
		$note = addslashes(JFactory::getApplication()->input->getString('note'));
		$abstract = addslashes(JFactory::getApplication()->input->getString('abstract'));
		$crossref = addslashes(JFactory::getApplication()->input->getString('crossref'));
		$keywords = addslashes(JFactory::getApplication()->input->getString('keywords'));
		$doi = addslashes(JFactory::getApplication()->input->getString('doi'));
		$url = addslashes(JFactory::getApplication()->input->getString('url'));
		$comment = addslashes(JFactory::getApplication()->input->getString('comment'));
		$owner = addslashes(JFactory::getApplication()->input->getString('owner'));
		$school = addslashes(JFactory::getApplication()->input->getString('school'));
		$type = addslashes(JFactory::getApplication()->input->getString('type'));
		$address = addslashes(JFactory::getApplication()->input->getString('address'));
		$citeseerurl = addslashes(JFactory::getApplication()->input->getString('citeseerurl'));
		$booktitle = addslashes(JFactory::getApplication()->input->getString('booktitle'));
		$editor = addslashes(JFactory::getApplication()->input->getString('editor'));
		$series = addslashes(JFactory::getApplication()->input->getString('series'));
		$organization = addslashes(JFactory::getApplication()->input->getString('organization'));
		$publisher = addslashes(JFactory::getApplication()->input->getString('publisher'));
		$institution = addslashes(JFactory::getApplication()->input->getString('institution'));
		$nCitas = addslashes(JFactory::getApplication()->input->getString('nCitas'));
		$factorImpacto = addslashes(JFactory::getApplication()->input->getString('impacto'));
		
		
		//obtenemos el autor principal de la publicacion
		$autores = explode(" and ",$author);
		$primerAutor = addslashes($autores[0]);
		
		//obtenemos el anyo de celebracion del congreso, en caso de ser distinto al de la publicacion.
		$anyoCelebracion = "";
		if ($entrytype == 'CONFERENCE'){
			$fechaCelebracion = explode(',', $month);
			$anyoCelebracion = end($fechaCelebracion);
		}
		
		
		//revisar de aki para abajo
		$db = & JFactory::getDBO();
		
		//insertamos el escrito
		//primero obtenemos el nombre del usuario
		$user = JFactory::getUser();
		$username = $user->get('username');
        
		$comprobarKey="SELECT id FROM #__publicaciones_escritos WHERE bibtextkey=\"".$bibtexkey."\";";
        $db->setQuery($comprobarKey,0);
		$db->query();
        $prueba=$db->getNumRows();
        if($prueba=!0){
            $res=3;   
        }
        else{
		$insertarEscrito = "INSERT INTO #__publicaciones_escritos VALUES ('','".$entrytype."','".$bibtexkey."','".$title."','".$author.
		"','".$journal."','".$year."','".$volume."','".$pages."','".$number."','".$month."','".$anyoCelebracion."','".$school."','".$eid.
		"','".$note."','".$abstract."','".$comment."','".$owner."','".$crossref."','".$keywords."','".$doi."','".$url."','".$type.
		"','".$address."','".$citeseerurl."','".$booktitle."','".$editor."','".$series."','".$organization."','".$publisher.
		"','".$institution."','".$primerAutor."','".$factorImpacto."', '".$nCitas."', NOW(), '".$username."','','1');";
		
		$db->setQuery($insertarEscrito,0);
		$db->query();
		$res = 1;
		
		//insertamos los autores
		$autores = explode(" and ",$author);
		
		for ($i = 0;$i < count($autores);$i++){
				
			//añadimos los datos necesarios a la tabla pertenece para ello:
			//sacamos la id del autor
			$consulta = "SELECT id FROM #__publicaciones_autor WHERE abreviado=\"".$autores[$i]."\";";
			$db->setQuery($consulta,0);
			
			$idAutor = 0;
			$rows = $db->loadObjectList();
			foreach($rows as $row){		
				$idAutor = $row->id;
			}	
			//separamos el nombre y apellido de los distintos autores
			$autorActual = $autores[$i];
			$name="";
			$surname="";
			//miramos a ver si tiene coma
			$nombreCompleto = explode(",", $autorActual);
			if ( count($nombreCompleto) == 1 ){
				//el nombre del autor esta en formato nombre apellido apellido
				$partes = explode(" ", $autorActual);
				$surname = $partes[count($partes) - 1];
				
				//echo $nombreCompleto . " " . count($partes);
				for ($j = 0; $j < count($partes)-1; $j++ ){
					$name = $name . " " . $partes[$j];
				}
			}else{
				//el formatod del nombre es apellido apellido, nombre
				$surname = $nombreCompleto[0];
				$name = $nombreCompleto[1];
			}
			
			
			if ($idAutor == 0){				
				//si no esta el autor lo añadimos a la base de datos
				$res = 2;
				$insertarAutores = "INSERT INTO #__publicaciones_autor VALUES('','".$autores[$i]."','','','".$name."','".$surname."',0)";
				$db->setQuery($insertarAutores,0);
				$db->query();
				
				$consulta2 = "SELECT id FROM #__publicaciones_autor WHERE abreviado=\"".$autores[$i]."\";";
				$db->setQuery($consulta2,0);
				
				$rows = $db->loadObjectList();
				foreach($rows as $row){		
					$idAutor = $row->id;
				}
			}
			
			//obtenemos la id del ultimo escrito añadido
			$consulta = "SELECT id FROM #__publicaciones_escritos;";
			$db->setQuery($consulta,0);
			$idTitulo = 0;
			$rows = $db->loadObjectList();
			foreach($rows as $row){
				$idEscrito = $row->id;
				if ($idEscrito > $idTitulo){
					$idTitulo = $idEscrito;
				}
			}
			
			//lo insertamos en la tabla pertenece
			$sentencia = "INSERT INTO #__publicaciones_pertenece (autor, escrito) VALUES (".$idAutor.",".$idTitulo.");";
			$db->setQuery($sentencia,0);
			$db->query();			
		}
        }	
		return $res;		
	}
	//función que introduce en la base de datos un artículo,congreso,tesis u otra publicación que se ha introducido en formato bibtex
	function introduceEscrito($post){
	
		$res = 1;
		$text = JFactory::getApplication()->input->getString('escrito');
		//$escrito = htmlentities($text);
		
		$text = str_replace("Ã¡","&aacute;",$text);
		$text = str_replace("Ã©","&eacute;",$text);
		$text = str_replace("Ã­","&iacute;",$text);
		$text = str_replace("Ã³","&oacute;",$text);
		$text = str_replace("Ãº","&uacute;",$text);
		$text = str_replace("Ã¡","&Aacute;",$text);
		$text = str_replace("Ã©","&Eacute;",$text);
		$text = str_replace("Ã­","&Iacute;",$text);
		$text = str_replace("Ã³","&Oacute;",$text);
		$text = str_replace("Ãº","&Uacute;",$text);
		$text = str_replace("Ã¤","&aauml;",$text);
		$text = str_replace("Ã«","&eauml;",$text);
		$text = str_replace("Ã¯","&iauml;",$text);
		$text = str_replace("Ã¶","&oauml;",$text);
		$text = str_replace("Ã¼","&uauml;",$text);
		$text = str_replace("Ã„","&Aauml;",$text);
		$text = str_replace("Ã‹","&Eauml;",$text);
		$text = str_replace("Ã","&Iauml;",$text);
		$text = str_replace("Ã–","&Oauml;",$text);
		$text = str_replace("Ãœ","&Uauml;",$text);		
		$text = str_replace("Ã¸","&oslash;",$text);
		$text = str_replace("Âº", "&deg;", $text);
		$text = str_replace("Ã…", "&Aring;", $text);
		//quitamos los caracteres raros del latex
		$text = str_replace("--","&mdash;",$text);
		$text = str_replace("\'a","&aacute;",$text);
		$text = str_replace("\'e","&eacute;",$text);
		$text = str_replace("\'i","&iacute;",$text);
		$text = str_replace("\'o","&oacute;",$text);
		$text = str_replace("\'u","&uacute;",$text);
		$text = str_replace("\'A","&Aacute;",$text);
		$text = str_replace("\'E","&Eacute;",$text);
		$text = str_replace("\'I","&Iacute;",$text);
		$text = str_replace("\'O","&Oacute;",$text);
		$text = str_replace("\'U","&Uacute;",$text);
		$text = str_replace("\\\"a","&auml;",$text);
		$text = str_replace("\\\"e","&euml;",$text);
		$text = str_replace("\\\"i","&iuml;",$text);
		$text = str_replace("\\\"o","&ouml;",$text);
		$text = str_replace("\\\"u","&uuml;",$text);
		$text = str_replace("\\\"A","&Auml;",$text);
		$text = str_replace("\\\"E","&Euml;",$text);
		$text = str_replace("\\\"I","&Iuml;",$text);
		$text = str_replace("\\\"O","&Ouml;",$text);
		$text = str_replace("\\\"U","&Uuml;",$text);
		$text = str_replace("{\ss}","&szlig;",$text);
		$escrito = $text;
		
		
		
		//lo separamos en cadenas
		$cadenas = explode(",",$escrito);
		$tamanio = strlen($cadenas[0]);
	
		//obtenemos el bibtexkey y el tipo de articulo
		$bibtexkeys = explode("{",$cadenas[0]);	
		$tipoarticulo = $bibtexkeys[0];
		$tipoarticulo = str_replace( "@", "", $tipoarticulo);
		$tipoarticulo = strtoupper($tipoarticulo);

		
		$bibtexkey = $bibtexkeys[1];
		//comprobamos que no tenga un bibtexkey igual a otro ya existente
		$db = & JFactory::getDBO();
		$consulta = "SELECT * FROM #__publicaciones_escritos WHERE bibtextkey like \"".$bibtexkey."\";";
		$db->setQuery($consulta,0);	
		$rows = $db->loadObjectList();
		
		if (count($rows)>0){
		    return 3;
		}
		
		$escrito = substr_replace($escrito,"",0,$tamanio + 1);
		
	
		//lo separamos en cadenas
		$cadenas = explode("},",$escrito);
		
		//quitamos los caracteres raros
		for ($i = 0;$i < count($cadenas);$i++){
			$cadenas[$i] = str_replace( "{", "", $cadenas[$i]);
			$cadenas[$i] = str_replace( "}", "", $cadenas[$i]);
		}
	
		for ($i = 0;$i < count($cadenas);$i++){
		
			//separamos cada una de las dos partes
			$aux = explode(" = ",$cadenas[$i]);
			//quitamos los espacios que aÃ±ade
			$aux[0] = str_replace(" ","",$aux[0]);
			//quitamos un par de caracteres raros que escribe al comienzo de la cadena
			$aux[0] = substr_replace($aux[0],"",0,2);
			
			$campo = strtolower($aux[0]);
			switch ($campo) {
				case "author":
					$author = addslashes($aux[1]);
					//quitamos saltos de linea tabulaciones y demas caracteres
					$author = eregi_replace("[\n|\r|\n\r]", ' ', $author);
					break;
				case "title":
					$title = addslashes($aux[1]);
					break;
				case "journal":
					$journal = addslashes($aux[1]);
					break;
				case "year":
					$year = addslashes($aux[1]);
					break;
				case "volume":
					$volume = addslashes($aux[1]);
					break;
				case "pages":
					$pages = addslashes($aux[1]);
					break;
			    case "timestamp":
			        $fecha = explode(".",$aux[1]);
			        $year = $fecha[0];
			        $month = $fecha[1];
			        break;
				case "number":
					$number = addslashes($aux[1]);
					break;
				case "month":
					$month = addslashes($aux[1]);
					break;
				case "eid":
					$eid = addslashes($aux[1]);
					break;
				case "note":
					$note = addslashes($aux[1]);
					break;
				case "abstract":
					$abstract = addslashes($aux[1]);
					break;
				case "comment":
					$comment = addslashes($aux[1]);
					break;
				case "owner":
					$owner = addslashes($aux[1]);
					break;
				case "school":
					$school = addslashes($aux[1]);
					break;
				case "crossref":
					$crossref = addslashes($aux[1]);
					break;
				case "keywords":
					$keywords = addslashes($aux[1]);
					break;
				case "doi":
					$doi = addslashes($aux[1]);
					break;
				case "url":
					$url = addslashes($aux[1]);
					break;
				case "type":
					$type = addslashes($aux[1]);
					break;
				case "address":
					$address = addslashes($aux[1]);
					break;
				case "citeseerurl":
					$citeseerurl = addslashes($aux[1]);
					break;
				case "booktitle":
					$booktitle = addslashes($aux[1]);
					break;
				case "editor":
					$editor = addslashes($aux[1]);
					break;
				case "series":
					$series = addslashes($aux[1]);
					break;
				case "organization":
					$organization = addslashes($aux[1]);
					break;
				case "publisher":
					$publisher = addslashes($aux[1]);
					break;
				case "institution":
					$institution = addslashes($aux[1]);
					break;
				case "times_cited":
					$cites = addslashes($aux[1]);
					break;
			}
		
		}
		//obtenemos el autor principal de la publicacion
		$autores = explode(" and ",$author);
		$primerAutor = addslashes($autores[0]);
		
		//obtenemos el anyo de celebracion del congreso, en caso de ser distinto al de la publicacion.
		$anyoCelebracion = "";
		if (strtoupper($entrytype) == 'CONFERENCE' || strtoupper($entrytype) == 'INPROCEEDINGS'){
			$fechaCelebracion = explode(',', $month);
			$anyoCelebracion = end($fechaCelebracion);
		}
		
		//conectamos con la base de datos
		$db = & JFactory::getDBO();
		
		//insertamos el escrito
		//primero obtenemos el nombre del usuario
		$user = JFactory::getUser();
		$username = $user->get('username');
        
		$insertarEscrito = "INSERT INTO #__publicaciones_escritos VALUES ('','".$tipoarticulo."','".$bibtexkey."','".$title."','".$author.
		"','".$journal."','".$year."','".$volume."','".$pages."','".$number."','".$month."','".$anyoCelebracion."','".$school."','".$eid."','".$note."','".$abstract.
		"','".$comment."','".$owner."','".$crossref."','".$keywords."','".$doi."','".$url."','".$type."','".$address."','".$citeseerurl.
		"','".$booktitle."','".$editor."','".$series."','".$organization."','".$publisher."','".$institution."','".$primerAutor.
		"', 0, '".$cites."', NOW(),'".$username."','','1');";
		
		
		$db->setQuery($insertarEscrito,0);
		$db->query();
		
		
		//insertamos los autores
		$autores = explode(" and ",$author);
		
		for ($i = 0;$i < count($autores);$i++){
				
			//anyadimos los datos necesarios a la tabla pertenece para ello:
			//sacamos la id del autor
			$consulta = "SELECT id FROM #__publicaciones_autor WHERE abreviado=\"".$autores[$i]."\";";
			$db->setQuery($consulta,0);
			
			$idAutor = 0;
			$rows = $db->loadObjectList();
			foreach($rows as $row){		
				$idAutor = $row->id;
			}	
			
			//separamos el nombre y apellido de los distintos autores
			$autorActual = $autores[$i];
			$name="";
			$surname="";
			//miramos a ver si tiene coma
			$nombreCompleto = explode(",", $autorActual);
			if ( count($nombreCompleto) == 1 ){
				//el nombre del autor esta en formato nombre apellido apellido
				$partes = explode(" ", $autorActual);
				$surname = $partes[count($partes) - 1];
				
				//echo $nombreCompleto . " " . count($partes);
				for ($j = 0; $j < count($partes)-1; $j++ ){
					$name = $name . " " . $partes[$j];
				}
			}else{
				//el formatod del nombre es apellido apellido, nombre
				$surname = $nombreCompleto[0];
				$name = $nombreCompleto[1];
			}
			
			if ($idAutor == 0){
				//si no esta el autor lo anyadimos a la base de datos
				$res = 2;
				$insertarAutores = "INSERT INTO #__publicaciones_autor VALUES('','".$autores[$i]."','','','".$name."','".$surname."',0)";
				$db->setQuery($insertarAutores,0);
				$db->query();
				
				$consulta2 = "SELECT id FROM #__publicaciones_autor WHERE abreviado=\"".$autores[$i]."\";";
				$db->setQuery($consulta2,0);
				
				$rows = $db->loadObjectList();
				foreach($rows as $row){		
					$idAutor = $row->id;
				}
			}
			
			//obtenemos la id del ultimo escrito anyadido
			$consulta = "SELECT id FROM #__publicaciones_escritos;";
			$db->setQuery($consulta,0);
			$idTitulo = 0;
			$rows = $db->loadObjectList();
			foreach($rows as $row){
				$idEscrito = $row->id;
				if ($idEscrito > $idTitulo){
					$idTitulo = $idEscrito;
				}
			}
			
			//lo insertamos en la tabla pertenece
			$sentencia = "INSERT INTO #__publicaciones_pertenece (autor, escrito) VALUES (".$idAutor.",".$idTitulo.");";
			$db->setQuery($sentencia,0);
			$db->query();			
		}				
		return $res;		
    }
	//función que lee el fichero .bib subido y lo divide en los diferetnes articulos
	function introduceFichero($post){
		$res = 1;
		$fichero = $_FILES['archivo']['tmp_name'];
		$archivo = $_FILES['archivo']['name'];
        $error = $_FILES['archivo']['error'];
		
		$r = explode(".", $archivo);
		$extension = $r[count($r)-1];
		
		//Utilizamos la funcion file_exists() para confirmar su existencia.
		if ($error==0){
			//comprobamos la extension del fichero
			if($extension!="bib"){
				return 4;
			}
				//Intentamos abrir el fichero.
				if ($ficheroabierto = fopen ($fichero, "r")){
					$escritos = fread($ficheroabierto,filesize($fichero));				
					$escrito = explode("@",$escritos);
					
					//separamos cada uno de los escritos
					for ($i = 1;$i<count($escrito);$i++){
						if (strlen($escrito[$i]) > 0){							
							$res = $this->introduceUno($escrito[$i]);
							if ($res == 2)
								$respuesta = 2;
							else if ($res == 3)
								$respuesta = 3;
						}
					}
					fclose($ficheroabierto);
					
				} else {
					echo "El fichero no ha podido ser abierto.";
				}
		} else {
				$res=0;
                echo "El fichero no existe.";
		}
	 return $res;
	}
    //funcion que guarda en la base de datos cada articulo por separado del fichero .bib
	function introduceUno($text){
		$res = 1;
		
		$text = str_replace("Ã¡","&aacute;",$text);
		$text = str_replace("Ã©","&eacute;",$text);
		$text = str_replace("Ã­","&iacute;",$text);
		$text = str_replace("Ã³","&oacute;",$text);
		$text = str_replace("Ãº","&uacute;",$text);
		$text = str_replace("Ã¡","&Aacute;",$text);
		$text = str_replace("Ã©","&Eacute;",$text);
		$text = str_replace("Ã­","&Iacute;",$text);
		$text = str_replace("Ã³","&Oacute;",$text);
		$text = str_replace("Ãº","&Uacute;",$text);
		$text = str_replace("Ã¤","&aauml;",$text);
		$text = str_replace("Ã«","&eauml;",$text);
		$text = str_replace("Ã¯","&iauml;",$text);
		$text = str_replace("Ã¶","&oauml;",$text);
		$text = str_replace("Ã¼","&uauml;",$text);
		$text = str_replace("Ã„","&Aauml;",$text);
		$text = str_replace("Ã‹","&Eauml;",$text);
		$text = str_replace("Ã","&Iauml;",$text);
		$text = str_replace("Ã–","&Oauml;",$text);
		$text = str_replace("Ãœ","&Uauml;",$text);
		$text = str_replace("Ã¸","&oslash;",$text);
		$text = str_replace("Âº", "&deg;", $text);
		$text = str_replace("Ã…", "&Aring;", $text);
		//quitamos los acentos de latex
		$text = str_replace("--","&mdash;",$text);
		$text = str_replace("\'a","&aacute;",$text);
		$text = str_replace("\'e","&eacute;",$text);
		$text = str_replace("\'i","&iacute;",$text);
		$text = str_replace("\'o","&oacute;",$text);
		$text = str_replace("\'u","&uacute;",$text);
		$text = str_replace("\'A","&Aacute;",$text);
		$text = str_replace("\'E","&Eacute;",$text);
		$text = str_replace("\'I","&Iacute;",$text);
		$text = str_replace("\'O","&Oacute;",$text);
		$text = str_replace("\'U","&Uacute;",$text);
		$text = str_replace("\\\"a","&auml;",$text);
		$text = str_replace("\\\"e","&euml;",$text);
		$text = str_replace("\\\"i","&iuml;",$text);
		$text = str_replace("\\\"o","&ouml;",$text);
		$text = str_replace("\\\"u","&uuml;",$text);
		$text = str_replace("\\\"A","&Auml;",$text);
		$text = str_replace("\\\"E","&Euml;",$text);
		$text = str_replace("\\\"I","&Iuml;",$text);
		$text = str_replace("\\\"O","&Ouml;",$text);
		$text = str_replace("\\\"U","&Uuml;",$text);
		$text = str_replace("{\ss}","&szlig;",$text);
		$escrito = $text;
		
		//lo separamos en cadenas
		$cadenas = explode(",",$escrito);
		$tamanio = strlen($cadenas[0]);

	
		//obtenemos el bibtexkey y el tipo de articulo
		$bibtexkeys = explode("{",$cadenas[0]);	
		$tipoarticulo = $bibtexkeys[0];
		$tipoarticulo = str_replace( "@", "", $tipoarticulo);
		$tipoarticulo = strtoupper($tipoarticulo);
		
		$bibtexkey = $bibtexkeys[1];
		//comprobamos que no tenga un bibtexkey igual a otro ya existente
		$db = & JFactory::getDBO();
		$consulta = "SELECT * FROM #__publicaciones_escritos WHERE bibtextkey like \"".$bibtexkey."\";";
		$db->setQuery($consulta,0);	
		$rows = $db->loadObjectList();
		
		if (count($rows)>0){
		    return 3;
		}
		
		$escrito = substr_replace($escrito,"",0,$tamanio + 1);
		$cadenas = explode("},",$escrito);
		//depende de con que programa se haga tendrÃ¡ unos resultados u otros		
		//quitamos los caracteres raros
		for ($i = 0;$i < count($cadenas);$i++){
			$cadenas[$i] = str_replace( "{", "", $cadenas[$i]);
			$cadenas[$i] = str_replace( "}", "", $cadenas[$i]);
		}
		for ($i = 0;$i < count($cadenas);$i++){
			
			//separamos cada una de las dos partes
			$aux = explode(" = ",$cadenas[$i]);
			//quitamos los espacios que aÃ±ade
			$aux[0] = str_replace(" ","",$aux[0]);
			//quitamos un par de caracteres raros que escribe al comienzo de la cadena, si aparecen
			if (ord($aux[0][0]) == 10 ){
				$aux[0] = substr_replace($aux[0],"",0,1);
			}
			$campo = strtolower($aux[0]);
			
			switch ($campo) {
				case "author":
					$author = addslashes(chop($aux[1]));
					//quitamos saltos de linea tabulaciones y demas caracteres
					$author = eregi_replace("[\n|\r|\n\r]", '', $author);
					break;
				case "title":
					$title = addslashes($aux[1]);
					break;
				case "journal":
					$journal = addslashes($aux[1]);
					break;
				case "year":
					$year = addslashes($aux[1]);
					break;
				case "volume":
					$volume = addslashes($aux[1]);
					break;
				case "pages":
					$pages = addslashes($aux[1]);
					break;
			    case "timestamp":
			        $fecha = explode(".",$aux[1]);
			        $year = $fecha[0];
			        $month = $fecha[1];
			        break;
				case "number":
					$number = addslashes($aux[1]);
					break;
				case "month":
					$month = addslashes($aux[1]);
					break;
				case "eid":
					$eid = addslashes($aux[1]);
					break;
				case "note":
					$note = addslashes($aux[1]);
					break;
				case "abstract":
					$abstract = addslashes($aux[1]);
					break;
				case "comment":
					$comment = addslashes($aux[1]);
					break;
				case "owner":
					$owner = addslashes($aux[1]);
					break;
				case "school":
					$school = addslashes($aux[1]);
					break;
				case "crossref":
					$crossref = addslashes($aux[1]);
					break;
				case "keywords":
					$keywords = addslashes($aux[1]);
					break;
				case "doi":
					$doi = addslashes($aux[1]);
					break;
				case "url":
					$url = addslashes($aux[1]);
					break;
				case "type":
					$type = addslashes($aux[1]);
					break;
				case "address":
					$address = addslashes($aux[1]);
					break;
				case "citeseerurl":
					$citeseerurl = addslashes($aux[1]);
					break;
				case "booktitle":
					$booktitle = addslashes($aux[1]);
					break;
				case "editor":
					$editor = addslashes($aux[1]);
					break;
				case "series":
					$series = addslashes($aux[1]);
					break;
				case "organization":
					$organization = addslashes($aux[1]);
					break;
				case "publisher":
					$publisher = addslashes($aux[1]);
					break;
				case "institution":
					$institution = addslashes($aux[1]);
					break;
				case "times_cited":
					$citas = addslashes($aux[1]);
					break;
			}
		}
		
		
		//obtenemos el autor principal de la publicacion
		$autores = explode(" and ",$author);
		$primerAutor = addslashes($autores[0]);
		
		//obtenemos el anyo de celebracion del congreso, en caso de ser distinto al de la publicacion.
		$anyoCelebracion = "";
		if (strtoupper($entrytype) == 'CONFERENCE' || strtoupper($entrytype) == 'INPROCEEDINGS'){
			$fechaCelebracion = explode(',', $month);
			$anyoCelebracion = end($fechaCelebracion);
		}
		
		
		$db = & JFactory::getDBO();
		
		//insertamos el escrito
		//primero obtenemos el nombre del usuario
		$user = JFactory::getUser();
		$username = $user->get('username');
        
		$insertarEscrito = "INSERT INTO #__publicaciones_escritos VALUES ('','".$tipoarticulo."','".$bibtexkey."','".$title."','".$author.
		"','".$journal."','".$year."','".$volume."','".$pages."','".$number."','".$month."','".$anyoCelebracion."','".$school.
		"','".$eid."','".$note."','".$abstract."','".$comment."','".$owner."','".$crossref."','".$keywords."','".$doi."','".$url.
		"','".$type."','".$address."','".$citeseerurl."','".$booktitle."','".$editor."','".$series."','".$organization."','".$publisher.
		"','".$institution."','".$primerAutor."', 0, '".$cites."', NOW(),'".$username."','','1');";
		
		$db->setQuery($insertarEscrito,0);
		$db->query();
		
		
		//insertamos los autores
		$autores = explode(" and ",$author);
		
		for ($i = 0;$i < count($autores);$i++){
				
			//anyadimos los datos necesarios a la tabla pertenece para ello:
			//sacamos la id del autor
			$consulta = "SELECT id FROM #__publicaciones_autor WHERE abreviado=\"".$autores[$i]."\";";
			$db->setQuery($consulta,0);
			
			$idAutor = 0;
			$rows = $db->loadObjectList();
			foreach($rows as $row){		
				$idAutor = $row->id;
			}	
			
			//separamos el nombre y apellido de los distintos autores
			$autorActual = $autores[$i];
			$name="";
			$surname="";
			//miramos a ver si tiene coma
			$nombreCompleto = explode(",", $autorActual);
			if ( count($nombreCompleto) == 1 ){
				//el nombre del autor esta en formato nombre apellido apellido
				$partes = explode(" ", $autorActual);
				$surname = $partes[count($partes) - 1];
				
				//echo $nombreCompleto . " " . count($partes);
				for ($j = 0; $j < count($partes)-1; $j++ ){
					$name = $name . " " . $partes[$j];
				}
			}else{
				//el formatod del nombre es apellido apellido, nombre
				$surname = $nombreCompleto[0];
				$name = $nombreCompleto[1];
			}
			
			if ($idAutor == 0){
				//si no esta el autor lo aÃ±adimos a la base de datos
				$res = 2;
				$insertarAutores = "INSERT INTO #__publicaciones_autor VALUES('','".$autores[$i]."','','','".$name."','".$surname."',0)";
				$db->setQuery($insertarAutores,0);
				$db->query();
				
				$consulta2 = "SELECT id FROM #__publicaciones_autor WHERE abreviado=\"".$autores[$i]."\";";
				$db->setQuery($consulta2,0);
				
				$rows = $db->loadObjectList();
				foreach($rows as $row){		
					$idAutor = $row->id;
				}
			}
			
			//obtenemos la id del ultimo escrito aÃ±adido
			$consulta = "SELECT id FROM #__publicaciones_escritos;";
			$db->setQuery($consulta,0);
			$idTitulo = 0;
			$rows = $db->loadObjectList();
			foreach($rows as $row){
				$idEscrito = $row->id;
				if ($idEscrito > $idTitulo){
					$idTitulo = $idEscrito;
				}
			}
			
			//lo insertamos en la tabla pertenece
			$sentencia = "INSERT INTO #__publicaciones_pertenece (autor, escrito) VALUES (".$idAutor.",".$idTitulo.");";
			$db->setQuery($sentencia,0);
			$db->query();			
		}			
		return $res;		
    }
    //funcion que busca en el wok un articulo por el doi y lo guarda en nuestra base de datos
    function introduceDoi($post){
        
    $buscardoi =JFactory::getApplication()->input->getString('buscardoi');
    $auth_url = "http://sauwok5.fecyt.es/search/esti/wokmws/ws/WOKMWSAuthenticate?wsdl";
    $auth_client = @new SoapClient($auth_url);
     
    try{
    	 $auth_response = $auth_client->authenticate();
    } catch (Exception $e) {  
    echo $e->getMessage(); 
    }
   

    $search_url = "http://sauwok5.fecyt.es/search/esti/wokmws/ws/WokSearchLite?wsdl";
    $search_client = @new SoapClient($search_url);
    $search_client->__setCookie('SID',$auth_response->return);

    $search_array = array(
    'queryParameters' => array(
    'databaseId' => 'WOS',
    'userQuery' => 'DO='.$buscardoi.'',
    'editions' => array(
      array('collection' => 'WOS', 'edition' => 'SSCI'),
      array('collection' => 'WOS', 'edition' => 'SCI'),
      array('collection' => 'WOS', 'edition' => 'AHCI'),
      array('collection' => 'WOS', 'edition' => 'ISTP'),
      array('collection' => 'WOS', 'edition' => 'ISSHP'),
      array('collection' => 'WOS', 'edition' => 'IC'),
      array('collection' => 'WOS', 'edition' => 'CCR'),
      array('collection' => 'WOS', 'edition' => 'BSCI'),
      array('collection' => 'WOS', 'edition' => 'BHCI')
    ),
    'queryLanguage' => 'en'
    ),
    'retrieveParameters' => array(
    'firstRecord' => '1',
    'count' => '1',
    'sortField' => array(
        array('name' => 'AU', 'sort' => 'D')
    )
    )
);

    
    try{
    $search_response = $search_client->search($search_array);
    } catch (Exception $e) {  
    echo $e->getMessage(); 
    }
    //echo $search_response;
    //print_r($search_response);
    //$auth_response = $auth_client->closeSession();
    }	
	
	function view_pathway(){
		global $mainframe;
				
		$breadcrumbs = & $mainframe->getPathWay();
		$breadcrumbs->addItem( JText::_('BIBTEX'),'' );
	}
     
     //FIN NUEVO
    public function __construct($config = array()) {
        parent::__construct($config);
    }

    /**
     * Method to auto-populate the model state.
     *
     * Note. Calling getState in this method will result in recursion.
     *
     * @since	1.6
     */
    protected function populateState($ordering = null, $direction = null) {

        // Initialise variables.
        $app = JFactory::getApplication();

        // List state information
        $limit = $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'));
        $this->setState('list.limit', $limit);

        $limitstart = JFactory::getApplication()->input->getInt('limitstart', 0);
        $this->setState('list.start', $limitstart);

        

        // List state information.
        parent::populateState($ordering, $direction);
    }

    /**
     * Build an SQL query to load the list data.
     *
     * @return	JDatabaseQuery
     * @since	1.6
     */
    protected function getListQuery() {
		$db		= $this->getDbo();
		$query	= $db->getQuery(true);
		return $query;
	}


	public function getItems() {
        return parent::getItems();
    }

}
