<?php

/**
 * @version     1.3.0
 * @package     com_verarticulos
 * @copyright   Copyright (C) 2014. Todos los derechos reservados.

 * @author      sergio carcel fernando <sergiocarfer@gmail.com> - http://
 */
defined('_JEXEC') or die;

jimport('joomla.application.component.modellist');

/**
 * Metodos que acceden a la base de datos del modelo verarticulos.
 */
class VerarticulosModelVerarticulos extends JModelList {

    //declaracion de variables
    
    var $datos;
	var $tesis;
	var $congresos;
	var $otrasPub;
	var $autores;
	var $anyos;
	var $articulosdeunapersona;
	var $articulosdeunapersonaPrimero;
	var $tesisdeunapersona;
	var $tesisdeunapersonaPrimero;
	var $congresosdeunaapersona;
	var $congresosdeunaapersonaPrimero;
	var $otrasdeunapersona;
	var $otrasdeunapersonaPrimero;
    
    /**
     * Constructor.
     *
     * @param    array    An optional associative array of configuration settings.
     * @see        JController
     * @since    1.6
     */
     
   //funcion que borra una publicacion
   public function borrarPublication($id){
	
		echo $id;
		
		$db = & JFactory::getDBO();
		
		$borrarColaboradores = "DELETE FROM  #__publicaciones_pertenece WHERE (escrito='".$id."');";
		$db->setQuery($borrarColaboradores);
		$db->query();
		
		$borrarPublicacion = "DELETE FROM #__publicaciones_escritos WHERE (id='".$id."');";
		$db->setQuery($borrarPublicacion);
		$db->query();		
		return 1;
	}
	//funcion que oculta una publicacion seleccionada
	public function ocultarPublication($id){
	
		echo $id;
		
		$db = & JFactory::getDBO();
		
		$ocultarPublicacion = "UPDATE #__publicaciones_escritos SET visible='0' WHERE (id='".$id."');";
		$db->setQuery($ocultarPublicacion);
		$db->query();
		return 1;
	}
	//funcion que desoculta una publicacion seleccionada
	public function desocultarPublication($id){
	
		echo $id;
		
		$db = & JFactory::getDBO();
		
		$ocultarPublicacion = "UPDATE #__publicaciones_escritos SET visible='1' WHERE (id='".$id."');";
		$db->setQuery($ocultarPublicacion);
		$db->query();
		
		return 1;
	}
//funcion que muestra los articulos	ordenados por ao y titulo
 public function getArticulos(){
		$anio = JFactory::getApplication()->input->getString('year');
		if ($anio == "" or $anio == "ninguno"){
			$anio = -1;
		}
		
        if (empty( $this->datos )){
			if ($anio == -1){
				$query = "SELECT * FROM #__publicaciones_escritos e WHERE (tipo = \"ARTICLE\") order by `year` desc, title;";
			}else{
			 //si se selecciono filtrar por ao solo se mostraran los de ese ao
				$query = "SELECT * FROM #__publicaciones_escritos e WHERE (tipo = \"ARTICLE\" and year = ".$anio.") order by `year` desc, title;";
			}
 
            $this->datos = $this->_getList( $query );
        }
 
        return $this->datos;
    }
	//funcion que muestra las tesis ordenadas por ao y titulo
	public function getTesis(){
		$anio = JFactory::getApplication()->input->getString('year');
		if ($anio == "" or $anio == "ninguno"){
			$anio = -1;
		}
		
        if (empty( $this->tesis )){
			if ($anio == -1){
				$query = "SELECT * FROM #__publicaciones_escritos e WHERE (tipo = \"PHDTHESIS\" ) order by `year` desc, title;";
			}else{
			 //si se selecciono filtrar por ao solo se mostraran los de ese ao
				$query = "SELECT * FROM #__publicaciones_escritos e WHERE (tipo = \"PHDTHESIS\" and year = ".$anio." )  order by `year` desc, title;";
			}	 
            $this->tesis = $this->_getList( $query );
        }
 
        return $this->tesis;
    }
    //funcion que muestra los congresos ordenadas por ao y titulo
    public function getCongresos(){
		$anio = JFactory::getApplication()->input->getString('year');
		if ($anio == "" or $anio == "ninguno"){
			$anio = -1;
		}
		
        if (empty( $this->congresos )){
			if ($anio == -1){
				$query = "SELECT * FROM #__publicaciones_escritos e WHERE ((tipo = \"CONFERENCE\" OR tipo = \"INPROCEEDINGS\" ) ) order by `anio` desc, `year` desc, title;";
			}else{
			 //si se selecciono filtrar por ao solo se mostraran los de ese ao
				$query = "SELECT * FROM #__publicaciones_escritos e WHERE ((tipo = \"CONFERENCE\" OR tipo = \"INPROCEEDINGS\") and anio = ".$anio." ) order by `anio` desc, `year` desc, title;";
			}
            $this->congresos = $this->_getList( $query );
        }
 
        return $this->congresos;
    }
    //funcion que muestra las otras publicaciones ordenadas por ao y titulo
    public function getOtrasPublicaciones(){
		$anio = JFactory::getApplication()->input->getString('year');
		if ($anio == "" or $anio == "ninguno"){
			$anio = -1;
		}
		
        if (empty( $this->otrasPub)){
			if($anio == -1){
				$query = "SELECT * FROM #__publicaciones_escritos e WHERE (tipo <> \"ARTICLE\" AND tipo <> \"PHDTHESIS\" AND tipo <> \"CONFERENCE\" AND tipo <> \"INPROCEEDINGS\") order by `year` desc, title;";
			}else{
			  //si se selecciono filtrar por ao solo se mostraran los de ese ao
				$query = "SELECT * FROM #__publicaciones_escritos e WHERE (tipo <> \"ARTICLE\" AND tipo <> \"PHDTHESIS\" AND tipo <> \"CONFERENCE\" AND tipo <> \"INPROCEEDINGS\" AND year = ".$anio.") order by `year` desc, title;";
			}
            $this->otrasPub = $this->_getList( $query );
        }
 
        return $this->otrasPub;
    }
	//funcion que busca todos los autores de la base de datos que no esten ignorados
	public function getAutores(){
		if (empty( $this->autores )){
		
            $query = "SELECT distinct nombre FROM #__publicaciones_autor WHERE nombre <> '' and ignorado = 0 ORDER BY nombre;";
 
            $this->autores = $this->_getList( $query );
        }
 
        return $this->autores;
	}
	//funcion que muestra todos los aos en los que hay publicaciones
	public function getAnyos(){
		if (empty( $this->anyos )){
		
            $query = "SELECT distinct year FROM #__publicaciones_escritos ORDER BY year desc;";
 
            $this->anyos = $this->_getList( $query );
        }
 
        return $this->anyos;
	}
	//funcion que filtra los articulos por autor
	public function getArticulosDeUnaPersona(){
		$persona = JFactory::getApplication()->input->getString('autor');
		$anio = JFactory::getApplication()->input->getString('year');
		
		if ($persona == ""){
			$persona = -1;
		}
		if ($persona == "ninguno"){
			$persona = -1;
		}
		if ($anio == "" or $anio == "ninguno"){
			$anio = -1;
		}
		
		if (empty( $this->articulosdeunapersona )){
		
            if ( $anio != -1 ){
				$query = "SELECT e.author,e.title,e.id,e.journal, e.volume, e.pages, e.month, e.year, e.url, e.visible FROM #__publicaciones_escritos "
				."e,#__publicaciones_pertenece p, #__publicaciones_autor a where (e.year = ".$anio." AND e.tipo = \"ARTICLE\" and e.id = p.escrito "
				." and p.autor = a.id and a.id in(SELECT id FROM  #__publicaciones_autor WHERE nombre = '".$persona."')) "
				."order by year desc, title;";
			}else{
				$query = "SELECT e.author,e.title,e.id,e.journal, e.volume, e.pages, e.month, e.year, e.url, e.visible FROM #__publicaciones_escritos "
				."e,#__publicaciones_pertenece p, #__publicaciones_autor a where (e.tipo = \"ARTICLE\" and e.id = p.escrito "
				."and p.autor = a.id and a.id in(SELECT id FROM  #__publicaciones_autor WHERE nombre = '".$persona."')) "
				."order by year desc, title;";
			}
			
            $this->articulosdeunapersona = $this->_getList( $query );
        }
        return $this->articulosdeunapersona;
	}
	//funcion que filtra los articulos por primer autor
	public function getArticulosDeUnaPersonaPrimero(){
		$persona = JFactory::getApplication()->input->getString('autor');
		$anio = JFactory::getApplication()->input->getString('year');
		if ($persona == ""){
			$persona = -1;
		}
		if ($persona == "ninguno"){
			$persona = -1;
		}
		if ($anio == "" or $anio == "ninguno"){
			$anio = -1;
		}
		
		if (empty( $this->articulosdeunapersonaPrimero )){
		
            if ($anio != -1){
				$query = "SELECT e.author,e.title,e.id,e.journal, e.volume, e.pages, e.month, e.year, e.url, e.visible FROM #__publicaciones_escritos "
				."e,#__publicaciones_pertenece p, #__publicaciones_autor a where (e.year = ".$anio." and e.tipo = \"ARTICLE\" and e.id = p.escrito "
				."and p.autor = a.id and a.id in(SELECT id FROM  #__publicaciones_autor WHERE nombre = '".$persona."') and e.primerAutor in (SELECT abreviado FROM  #__publicaciones_autor WHERE nombre = '".$persona."'))"
				."order by `year` desc, title;";
			}else{
				$query = "SELECT e.author,e.title,e.id,e.journal, e.volume, e.pages, e.month, e.year, e.url, e.visible FROM #__publicaciones_escritos "
				."e,#__publicaciones_pertenece p, #__publicaciones_autor a where (e.tipo = \"ARTICLE\" and e.id = p.escrito "
				."and p.autor = a.id and a.id in(SELECT id FROM  #__publicaciones_autor WHERE nombre = '".$persona."') and e.primerAutor in (SELECT abreviado FROM  #__publicaciones_autor WHERE nombre = '".$persona."'))"
				."order by `year` desc, title;";
			}
            $this->articulosdeunapersonaPrimero = $this->_getList( $query );
        }
 
        return $this->articulosdeunapersonaPrimero;
	}
	//funcion que filtra las tesis por autor
	public function getTesisDeUnaPersona(){
		$persona = JFactory::getApplication()->input->getString('autor');
		$anio = JFactory::getApplication()->input->getString('year');
		if ($persona == ""){
			$persona = -1;
		}
		if ($persona == "ninguno"){
			$persona = -1;
		}
		if ($anio == "" or $anio == "ninguno"){
			$anio = -1;
		}
		
		if (empty( $this->tesisdeunapersona )){
			if ($anio != -1){
				$query = "SELECT e.author,e.title, e.id, e.journal, e.tipo, e.volume, e.pages, e.year, e.month, e.author, e.school, e.url, e.booktitle, e.note, e.visible FROM ".
				"#__publicaciones_escritos e,#__publicaciones_pertenece p, #__publicaciones_autor a where (e.year = ".$anio." AND  e.tipo = \"PHDTHESIS\" and ".
				"e.id = p.escrito and p.autor = a.id and a.id in (SELECT id FROM #__publicaciones_autor WHERE nombre = '".$persona."'))".
				"order by `year` desc, title;";
			}else{
				$query = "SELECT e.author,e.title, e.id, e.journal, e.tipo, e.volume, e.pages, e.year, e.month, e.author, e.school, e.url, e.booktitle, e.note, e.visible FROM ".
				"#__publicaciones_escritos e,#__publicaciones_pertenece p, #__publicaciones_autor a where (e.tipo = \"PHDTHESIS\" and ".
				"e.id = p.escrito and p.autor = a.id and a.id in (SELECT id FROM #__publicaciones_autor WHERE nombre = '".$persona."'))".
				"order by `year` desc, title;";
			}
            $this->tesisdeunapersona = $this->_getList( $query );
        }
 
        return $this->tesisdeunapersona;
	}
		//funcion que filtra las tesis por primer autor
	public function getTesisDeUnaPersonaPrimero(){
		$persona = JFactory::getApplication()->input->getString('autor');
		$anio = JFactory::getApplication()->input->getString('year');
		if ($persona == ""){
			$persona = -1;
		}
		if ($persona == "ninguno"){
			$persona = -1;
		}
		if ($anio == "" or $anio == "ninguno"){
			$anio = -1;
		}
		
		if (empty( $this->tesisdeunapersonaPrimero )){
            if($anio != -1){
				$query = "SELECT e.author,e.title, e.id, e.journal, e.tipo, e.volume, e.pages, e.year, e.month, e.author, e.school, e.url, e.booktitle, e.note, e.visible FROM ".
				"#__publicaciones_escritos e,#__publicaciones_pertenece p, #__publicaciones_autor a where (e.year = ".$anio." AND e.tipo = \"PHDTHESIS\" and ".
				"e.id = p.escrito and p.autor = a.id and a.id in (SELECT id FROM #__publicaciones_autor WHERE nombre = '".$persona."') ".
				" and e.primerAutor in (SELECT abreviado FROM  #__publicaciones_autor WHERE nombre = '".$persona."')) order by `year` desc, title;";
			}else{
				$query = "SELECT e.author,e.title, e.id, e.journal, e.tipo, e.volume, e.pages, e.year, e.month, e.author, e.school, e.url, e.booktitle, e.note, e.visible FROM ".
			"#__publicaciones_escritos e,#__publicaciones_pertenece p, #__publicaciones_autor a where ( e.tipo = \"PHDTHESIS\" and ".
			"e.id = p.escrito and p.autor = a.id and a.id in (SELECT id FROM #__publicaciones_autor WHERE nombre = '".$persona."') ".
			" and e.primerAutor in (SELECT abreviado FROM  #__publicaciones_autor WHERE nombre = '".$persona."')) order by `year` desc, title;";
			}
            $this->tesisdeunapersonaPrimero = $this->_getList( $query );
        }
 
        return $this->tesisdeunapersonaPrimero;
	}
	//funcion que filtra los congresos por autor
	public function getCongresosDeUnaPersona(){
		$persona = JFactory::getApplication()->input->getString('autor');
		$anio = JFactory::getApplication()->input->getString('year');
		if ($persona == ""){
			$persona = -1;
		}
		if ($persona == "ninguno"){
			$persona = -1;
		}
		if ($anio == "" or $anio == "ninguno"){
			$anio = -1;
		}
		
		if (empty( $this->congresosdeunapersona )){
			if($anio != -1 ){
				$query = "SELECT e.author,e.title, e.id, e.journal, e.tipo, e.volume, e.pages, e.year, e.month, e.author, e.school, e.url, e.booktitle, e.note, e.visible FROM ".
				"#__publicaciones_escritos e,#__publicaciones_pertenece p, #__publicaciones_autor a where (e.anio = ".$anio." AND (e.tipo = \"CONFERENCE\" OR e.tipo = \"INPROCEEDINGS\") and ".
				"e.id = p.escrito and p.autor = a.id and a.id in (SELECT id FROM #__publicaciones_autor WHERE nombre = '".$persona."'))".
				"order by `anio` desc, `year` desc, title;";
			}else{
				$query = "SELECT e.author,e.title, e.id, e.journal, e.tipo, e.volume, e.pages, e.year, e.month, e.author, e.school, e.url, e.booktitle, e.note, e.visible FROM ".
			"#__publicaciones_escritos e,#__publicaciones_pertenece p, #__publicaciones_autor a where ( (e.tipo = \"CONFERENCE\" OR e.tipo = \"INPROCEEDINGS\") and ".
			"e.id = p.escrito and p.autor = a.id and a.id in (SELECT id FROM #__publicaciones_autor WHERE nombre = '".$persona."'))".
			"order by `anio` desc, `year` desc, title;";
			}
 
            $this->congresosdeunapersona = $this->_getList( $query );
        }
 
        return $this->congresosdeunapersona;
	}
	//funcion que filtra los congresos por  primer autor
	public function getCongresosDeUnaPersonaPrimero(){
		$persona = JFactory::getApplication()->input->getString('autor');
		$anio = JFactory::getApplication()->input->getString('year');
		if ($persona == ""){
			$persona = -1;
		}
		if ($persona == "ninguno"){
			$persona = -1;
		}
		if ($anio == "" or $anio == "ninguno"){
			$anio = -1;
		}
		
		if (empty( $this->congresosdeunapersonaPrimero )){
			if( $anio != -1 ){
				$query = "SELECT e.author,e.title, e.id, e.journal, e.tipo, e.volume, e.pages, e.year, e.month, e.author, e.school, e.url, e.booktitle, e.note, e.visible FROM ".
				"#__publicaciones_escritos e,#__publicaciones_pertenece p, #__publicaciones_autor a where (e.anio=".$anio." AND (e.tipo = \"CONFERENCE\" OR e.tipo = \"INPROCEEDINGS\") and ".
				"e.id = p.escrito and p.autor = a.id and a.id in (SELECT id FROM #__publicaciones_autor WHERE nombre = '".$persona."')".
				" and e.primerAutor in (SELECT abreviado FROM  #__publicaciones_autor WHERE nombre = '".$persona."')) order by `anio` desc, `year` desc, title;";
			}else{
				$query = "SELECT e.author,e.title, e.id, e.journal, e.tipo, e.volume, e.pages, e.year, e.month, e.author, e.school, e.url, e.booktitle, e.note, e.visible FROM ".
			"#__publicaciones_escritos e,#__publicaciones_pertenece p, #__publicaciones_autor a where ( (e.tipo = \"CONFERENCE\" OR e.tipo = \"INPROCEEDINGS\") and ".
			"e.id = p.escrito and p.autor = a.id and a.id in (SELECT id FROM #__publicaciones_autor WHERE nombre = '".$persona."')".
			" and e.primerAutor in (SELECT abreviado FROM  #__publicaciones_autor WHERE nombre = '".$persona."')) order by `anio` desc, `year` desc, title;";
			}
            $this->congresosdeunapersonaPrimero = $this->_getList( $query );
        }
 
        return $this->congresosdeunapersonaPrimero;
	}
	//funcion que filtra otras publicaciones por autor
	public function getOtrasPubDeUnaPersona(){
		$persona = JFactory::getApplication()->input->getString('autor');
		$anio = JFactory::getApplication()->input->getString('year');
		if ($persona == ""){
			$persona = -1;
		}
		if ($persona == "ninguno"){
			$persona = -1;
		}
		if ($anio == "" or $anio == "ninguno"){
			$anio = -1;
		}
		
		if (empty( $this->otrasdeunapersona )){
			if( $anio != -1 ){
				$query = "SELECT e.author,e.title, e.id, e.journal, e.tipo, e.volume, e.pages, e.year, e.month, e.author, e.school, e.url, e.visible FROM ".
				"#__publicaciones_escritos e,#__publicaciones_pertenece p, #__publicaciones_autor a where (e.year = ".$anio." AND e.tipo <> \"PHDTHESIS\" and ".
				"e.tipo <> \"ARTICLE\" and e.tipo <> \"CONFERENCE\" AND e.tipo <> \"INPROCEEDINGS\" and e.id = p.escrito and p.autor = a.id and a.id in (SELECT id FROM ".
				"#__publicaciones_autor WHERE nombre = '".$persona."')) order by `year` desc, title;";
			}else{
				$query = "SELECT e.author,e.title, e.id, e.journal, e.tipo, e.volume, e.pages, e.year, e.month, e.author, e.school, e.url, e.visible FROM ".
			"#__publicaciones_escritos e,#__publicaciones_pertenece p, #__publicaciones_autor a where ( e.tipo <> \"PHDTHESIS\" and ".
			"e.tipo <> \"ARTICLE\" and e.tipo <> \"CONFERENCE\" AND e.tipo <> \"INPROCEEDINGS\" and e.id = p.escrito and p.autor = a.id and a.id in (SELECT id FROM ".
			"#__publicaciones_autor WHERE nombre = '".$persona."')) order by `year` desc, title;";
			}
            $this->otrasdeunapersona = $this->_getList( $query );
        }
 
        return $this->otrasdeunapersona;
	}
	//funcion que filtra otras publicaciones por primer autor
	public function getOtrasPubDeUnaPersonaPrimero(){
	
		$persona = JFactory::getApplication()->input->getString('autor');
		$anio = JFactory::getApplication()->input->getString('year');
		if ($persona == ""){
			$persona = -1;
		}
		if ($persona == "ninguno"){
			$persona = -1;
		}
		if ($anio == "" or $anio == "ninguno"){
			$anio = -1;
		}
		
		if (empty( $this->otrasdeunapersonaPrimero )){
			if( $anio != -1){
				$query = "SELECT e.author,e.title, e.id, e.journal, e.tipo, e.volume, e.pages, e.year, e.month, e.author, e.school, e.url, e.visible FROM ".
				"#__publicaciones_escritos e,#__publicaciones_pertenece p, #__publicaciones_autor a where (e.year = ".$anio." AND e.tipo <> \"PHDTHESIS\" and ".
				"e.tipo <> \"ARTICLE\" and e.tipo <> \"CONFERENCE\" AND e.tipo <> \"INPROCEEDINGS\" and e.id = p.escrito and p.autor = a.id and a.id in (SELECT id FROM ".
				"#__publicaciones_autor WHERE nombre = '".$persona."') and e.primerAutor in (SELECT abreviado FROM  #__publicaciones_autor WHERE nombre = '".$persona."')) ".
				"order by `year` desc, title;";
			}else{
				$query = "SELECT e.author,e.title, e.id, e.journal, e.tipo, e.volume, e.pages, e.year, e.month, e.author, e.school, e.url, e.visible FROM ".
			"#__publicaciones_escritos e,#__publicaciones_pertenece p, #__publicaciones_autor a where ( e.tipo <> \"PHDTHESIS\" and ".
			"e.tipo <> \"ARTICLE\" and e.tipo <> \"CONFERENCE\" AND e.tipo <> \"INPROCEEDINGS\" and e.id = p.escrito and p.autor = a.id and a.id in (SELECT id FROM ".
			"#__publicaciones_autor WHERE nombre = '".$persona."') and e.primerAutor in (SELECT abreviado FROM  #__publicaciones_autor WHERE nombre = '".$persona."')) ".
			"order by `year` desc, title;";
			}
            $this->otrasdeunapersonaPrimero = $this->_getList( $query );
        }
 
        return $this->otrasdeunapersonaPrimero;
	}
	//funcion que muestra el breadcrumbs
	public function view_pathway(){
		global $mainframe;
	
		$autor = JFactory::getApplication()->input->getString('autor');
		$anio = JFactory::getApplication()->input->getString('year');
		$mostrarInvisibles = JFactory::getApplication()->input->get('mostrarInvisibles');
		if($autor == ''){			
			$breadcrumbs = & $mainframe->getPathWay();
			$breadcrumbs->addItem( JText::_('PRESENTACIONES'),'' );
		}else{
			if($autor=='ninguno'){
				if ($anio == 'ninguno'){
					$breadcrumbs = & $mainframe->getPathWay();
					$breadcrumbs->addItem( JText::_('PRESENTACIONES'),'' );
				}else{
					$breadcrumbs = & $mainframe->getPathWay();
					$breadcrumbs->addItem( JText::_('PRESENTACIONES'), sefRelToAbs( "index.php?option=com_verarticulos&mostrarInvisibles=".$mostrarInvisibles ) );
					$breadcrumbs->addItem( $anio, '' );
				}
			}else{
				$breadcrumbs = & $mainframe->getPathWay();
				$breadcrumbs->addItem( JText::_('PRESENTACIONES'), sefRelToAbs( "index.php?option=com_verarticulos&mostrarInvisibles=".$mostrarInvisibles ) );
				if ($anio == "ninguno" || $anio == ""){
					$breadcrumbs->addItem( $autor, '' );
				}else{
					$breadcrumbs->addItem( $autor." (".$anio.")", '' );
				}
			}
		}
	}
    public function __construct($config = array()) {
        parent::__construct($config);
    }

    /**
     * Method to auto-populate the model state.
     *
     * Note. Calling getState in this method will result in recursion.
     *
     * @since	1.6
     */
    protected function populateState($ordering = null, $direction = null) {

        // Initialise variables.
        $app = JFactory::getApplication();

        // List state information
        $limit = $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'));
        $this->setState('list.limit', $limit);

        $limitstart = JFactory::getApplication()->input->getInt('limitstart', 0);
        $this->setState('list.start', $limitstart);

        

        // List state information.
        parent::populateState($ordering, $direction);
    }

    /**
     * Build an SQL query to load the list data.
     *
     * @return	JDatabaseQuery
     * @since	1.6
     */
    protected function getListQuery() {
		$db		= $this->getDbo();
		$query	= $db->getQuery(true);
		return $query;
	}


	public function getItems() {
        return parent::getItems();
    }

}
